# Music Band Manager

## Developers
- Dávid Želník @xzelnik (Team leader), učo: 469323
- Zuzana Tunegová @xtunegov, učo: 469439
- Pavel Vašina @xvasina, učo: 445606
- David Sapák @xsapak1, učo: 527353

## Project assignment
The web application allows one music band to manage their activities. Managers can create a new band and start hiring team members from a catalogue. They can set for the band the musical style (e.g. rock, pop, etc…), a name, and a logo. Band managers can add new albums and songs to a band. Each Song has a name and a duration. Managers can also schedule tours for the bands, in terms of dates and cities visited.
Team members can login to the system and see the offers made by the band managers. They can accept or reject to be part of a band. After they are part of a band, they can see all the activities that are planned and the profiles of the other band members.

## How to run the app
- `cd mbm-ui && mvn clean install` compile sources

## How to run backend
- `mvn spring-boot:run` 
- REST API avalable at http://localhost:8080/pa165/rest

# Use case diagram
![Use case diagram](docs/UseCaseDiagram.jpg)

# Class diagram 
![Class diagram](docs/ClassDiagram.png)

## Entity
- **Band**
    - Entity consists of band members. Band has a type, which represents style of the music in their albums and songs. 
    - Band is identified by id, name and type, also has its own logo.
- **Musician**
    - Entity is identified by id, name and musician type (singer, pianist etc.) 
    - Musician can login to system, see the offers and accept/reject offer.
    - If musician is member of the band: 
        - can see band activities,
        - can see profiles of other band members.
- **Activity**
  - Entity indetified by name and id, also has date.
- **Manager**
    - Entity manager can create band and hire musicians from catalogue.
    - Also can add albums, song, musical style, band name, logo and schedule tours.
- **Album**
    - Entity consists of songs, name and band.
- **Song**
    - Entity indetified by name and id, also has duration.


