package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Activity;

import java.util.List;

/**
 * @author Dávid Želník - 469323
 */
public interface ActivityDao {

    /**
     * Persists given Activity entity
     * @param Activity to be persisted
     */
    Activity create(Activity Activity);

    /**
     * Tries to find Activity with given id
     * @param id given id
     * @return correct Activity
     */
    Activity findById(String id);

    /**
     * Tries to find Activity by given name
     * @param name given name
     * @return list of Activities with given name
     */
    List<Activity> findByName(String name);

    /**
     * Merges given Activity
     * @param activity given Activity
     */
    Activity update(Activity activity);

    /**
     * Deletes given Activity if it exists in database
     * @param activity given Activity
     */
    Activity delete(Activity activity);

    /**
     * Finds all instances of Activity
     * @return list of all Activities
     */
    List<Activity> findAll();
}
