package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Album;
import java.util.List;

/**
 * @author David Sapák
 */
public interface AlbumDao {

    /**
     * Creates new entity
     * @param album Entity to be created
     */
    Album create(Album album);

    /**
     * Find entity by Id
     * @param Id Id of searching entity
     * @return found entity
     */
    Album findById(String Id) ;

    /**
     * Finds entity by name
     * @param name Name of entity to be found
     * @return List of entities with searched name
     */
    List<Album> findByName(String name) ;

    /**
     * Updates entity
     * @param album entity to be updated
     */
    Album update(Album album) ;

    /**
     * Deletes entity
     * @param album entity to be deleted
     */
    Album delete(Album album) ;

    /**
     *
     * @return all albums from database
     */
    List<Album> findAll();
}
