package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Activity;
import cz.fi.muni.pa165.entity.Band;

import java.util.List;

/**
 * @author Dávid Želník - 469323
 */
public interface BandDao {

    /**
     * Persists given Band entity
     * @param band Band to be persisted
     */
    Band create(Band band);

    /**
     * Tries to find Band with given id
     * @param id given id
     * @return Band with given id
     */
    Band findById(String id);

    /**
     * Tries to find Band by given name
     * @param name given name
     * @return list of Bands with given name
     */
    List<Band> findByName(String name);

    /**
     * Merges given Band
     * @param band given Band
     */
    Band update(Band band);

    /**
     * Deletes given Band if it exists in database
     * @param band given Band
     */
    Band delete(Band band);

    /**
     * Finds all instances of Band
     * @return list of all Bands
     */
    List<Band> findAll();
}
