package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Manager;

import java.util.List;


/**
 * @author Pavel Vašina - 445606
 */
public interface ManagerDao {

    /**
     * Create new manager entity
     * @param manager entity to be created
     * @return created manager entity
     */
    Manager create(Manager manager);

    /**
     * Find Manager entity by id
     * @param id Id of searched Manager
     * @return found Manager entity
     */
    Manager findById(String id);

    /**
     * Find Manager entity by name
     * @param name name of searched Manager
     * @return found corresponding Manager entities List
     */
    List<Manager> findByName(String name);

    /**
     * Update Manager entity
     * @param manager Manager entity to be updated
     * @return updated Manager entity
     */
    Manager update(Manager manager);

    /**
     * Delete Manager entity
     * @param manager Manager entity to be deleted
     * @return deleted Manager entity
     */
    Manager delete(Manager manager);


    /**
     * Finds all managers
     * @return list of all managers
     */
    List<Manager> findAll();
}
