package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Song;

import java.util.List;

/**
 * @author David Sapák
 */
public interface SongDao {
    /**
     * Creates an entity
     * @param song new entity values
     */
    Song create(Song song);

    /**
     * Finds entity by Id
     * @param Id
     * @return
     */
    Song findById(String Id) ;

    /**
     * Finds entities by name
     * @param name name of the entities
     * @return list of the found entities
     */
    List<Song> findByName(String name) ;

    /**
     * Updates entity
     * @param song New updated entity
     */
    Song update(Song song) ;

    /**
     * Deletes entity
     * @param song Entity that should be deleted
     */
    Song delete(Song song) ;

    /**
     *
     * @return list of all songs
     */
    List<Song> findAll();
}
