package cz.fi.muni.pa165.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;
import java.util.UUID;

/**
 * @author Dávid Želník - 469323
 */
@Entity
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class Activity {

    @Id
    @NotNull
    private String id = UUID.randomUUID().toString();

    @NotNull
    private String name;

    @NotNull
    private LocalDateTime time;

    @ManyToOne
    @JoinColumn(name="band_id")
    private Band band;

    @Override
    public boolean equals(Object o) {
        if (o == null)
            return false;
        if (this == o)
            return true;
        if (!(o instanceof Activity))
            return false;
        Activity activity = (Activity) o;
        return getId().equals(activity.getId());
    }

    @Override
    public int hashCode() {
        final int prime = 71;
        return prime * (getId() != null ? getId().hashCode() : 0);
    }

    @Override
    public String toString() {
        return "Activity{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", time=" + time +
                ", band=" + band +
                '}';
    }
}
