package cz.fi.muni.pa165.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.*;

/**
 * @author Pavel Vašina - 445606
 */
@Entity
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class Manager {

    @Id
    @NotNull
    private String id = UUID.randomUUID().toString();

    @NotNull
    @Column(nullable = false)
    private String name;

    @OneToMany(mappedBy = "id") private Set<Band> managedBands = new LinkedHashSet<>();

    public Set<Band> addManagedBand(Band band){
        managedBands.add(band);
        return managedBands;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null) return false;
        if (!(o instanceof Manager)) return false;
        Manager manager = (Manager) o;
        return getId().equals(manager.getId());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Manager{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", managedBands=" + managedBands +
                '}';
    }
}
