package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.enums.MusicianType;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

/**
 * @author Zuzana Tunegová
 */
@Entity
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class Musician {

    @Id
    @NotNull
    private String id = UUID.randomUUID().toString();

    @NotNull
    private String name;

    @NotNull
    @Enumerated(EnumType.STRING)
    private MusicianType type;

    @NotNull
    private boolean hasBand = false;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Musician))
            return false;
        Musician musician = (Musician) o;
        return getId().equals(musician.getId());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Musician {" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", type=" + type +
                '}';
    }
}
