package cz.fi.muni.pa165.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.sql.Time;
import java.time.Duration;
import java.util.UUID;


/**
 * @author David Sapák
 */
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class Song {
    @Id
    @NotNull
    private String id = UUID.randomUUID().toString();

    @NotNull
    @Column(nullable = false)
    private String songName;

    @NotNull
    @Column(nullable = false)
    private Duration duration;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Song))
            return false;
        Song song = (Song) o;
        return getId().equals(song.getId());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Song{" +
                "id=" + id +
                ", songName='" + songName + '\'' +
                ", duration=" + duration +
                '}';
    }
}
