package cz.fi.muni.pa165.enums;

import java.util.Arrays;
import java.util.Objects;
import java.util.Optional;

/**
 * @author Dávid Želník - 469323
 */
public enum BandType {
    ROCK,
    POP,
    COUNTRY,
    METAL,
    PUNK;

    public static BandType convertFrom(String bandType) {
        if (bandType == null || bandType.isEmpty())
            return null;

        Optional<BandType> result = Arrays.stream(BandType.values())
                .filter(type -> Objects.equals(type.name().toLowerCase(), bandType.toLowerCase()))
                .findFirst();
        return result.orElse(null);
    }
}
