package cz.fi.muni.pa165.enums;

import java.util.Arrays;
import java.util.Objects;
import java.util.Optional;

public enum MusicianType {
    GUITARIST, SINGER, DRUMMER, BASS_GUITARIST, PIANIST, VIOLINIST;

    public static MusicianType convertFrom(String musicianType) {
        if (musicianType == null || musicianType.isEmpty())
            return null;

        Optional<MusicianType> result = Arrays.stream(MusicianType.values())
                .filter(type -> Objects.equals(type.name().toLowerCase(), musicianType.toLowerCase()))
                .findFirst();
        return result.orElse(null);
    }
}
