package cz.fi.muni.pa165.enums;

import lombok.Getter;

import java.util.Arrays;
import java.util.Objects;
import java.util.Optional;

@Getter
public enum UserRole {

    MUSICIAN("ROLE_MUSICIAN"), MANAGER("ROLE_MANAGER");

    private final String roleName;


    UserRole(String roleName) {
        this.roleName = roleName;
    }

    public static UserRole convertFrom(String userRole) {
        if (userRole == null || userRole.isEmpty())
            return null;

        Optional<UserRole> result = Arrays.stream(UserRole.values())
                .filter(type -> Objects.equals(type.name().toLowerCase(), userRole.toLowerCase()))
                .findFirst();
        return result.orElse(null);
    }
}

