package cz.fi.muni.pa165.mapper;

import cz.fi.muni.pa165.ManagerService;
import cz.fi.muni.pa165.dto.activity.ActivityCreateDto;
import cz.fi.muni.pa165.dto.album.AlbumCreateDto;
import cz.fi.muni.pa165.dto.band.BandCreateDto;
import cz.fi.muni.pa165.dto.manager.ManagerCreateDto;
import cz.fi.muni.pa165.dto.musician.MusicianCreateDto;
import cz.fi.muni.pa165.dto.offer.OfferCreateDto;
import cz.fi.muni.pa165.dto.song.SongCreateDto;
import cz.fi.muni.pa165.dto.user.UserCreateDto;
import cz.fi.muni.pa165.entity.*;
import cz.fi.muni.pa165.enums.BandType;
import cz.fi.muni.pa165.enums.MusicianType;
import cz.fi.muni.pa165.enums.UserRole;

public class CreateDtoMapper {

    public static Musician mapToEntity(MusicianCreateDto musicianCreateDto){
        Musician musician = new Musician();
        musician.setName(musicianCreateDto.getName());
        musician.setType(MusicianType.convertFrom(musicianCreateDto.getMusicianType()));
        musician.setHasBand(musicianCreateDto.isHasBand());
        return musician;
    }

    public static Musician mergeToEntity(MusicianCreateDto musicianCreateDto, Musician musician){
        musician.setName(musicianCreateDto.getName());
        musician.setType(MusicianType.convertFrom(musicianCreateDto.getMusicianType()));
        musician.setHasBand(musicianCreateDto.isHasBand());
        return musician;
    }

    public static Offer mapToEntity(OfferCreateDto offerCreateDto){
        Offer offer = new Offer();
        offer.setName(offerCreateDto.getName());
        return offer;
    }

    public static Offer mergedToEntity(OfferCreateDto offerCreateDto, Offer offer){
        offer.setName(offerCreateDto.getName());
        return offer;
    }

    public static Activity mapToEntity(ActivityCreateDto activityCreateDto){
        Activity activity = new Activity();
        activity.setName(activityCreateDto.getName());
        activity.setTime(activityCreateDto.getTime());
        return activity;
    }

    public static Activity mergeToEntity(ActivityCreateDto activityCreateDto, Activity activity){
        activity.setName(activityCreateDto.getName());
        activity.setTime(activityCreateDto.getTime());
        return activity;
    }

    public static Band mapToEntity(BandCreateDto bandCreateDto){
        Band band = new Band();
        band.setName(bandCreateDto.getName());
        band.setLogo(bandCreateDto.getLogo());
        band.setType(BandType.convertFrom(bandCreateDto.getBandType()));
        return band;
    }

    public static Band mergeToEntity(BandCreateDto bandCreateDto, Band band){
        band.setName(bandCreateDto.getName());
        band.setLogo(bandCreateDto.getLogo());
        band.setType(BandType.convertFrom(bandCreateDto.getBandType()));
        return band;
    }

    public static Manager mapToEntity(ManagerCreateDto managerCreateDto){
        Manager manager = new Manager();
        manager.setName(managerCreateDto.getName());
        return manager;
    }

    public static Manager mergeToEntity(ManagerCreateDto managerCreateDto, Manager manager){
        manager.setName(managerCreateDto.getName());
        return manager;
    }

    public static Album mapToEntity(AlbumCreateDto albumCreateDto){
        Album album = new Album();
        album.setName(albumCreateDto.getName());
        return album;
    }

    public static Album mergeToEntity(AlbumCreateDto albumCreateDto, Album album){
        album.setName(albumCreateDto.getName());
        return album;
    }

    public static Song mapToEntity(SongCreateDto songCreateDto){
        Song song = new Song();
        song.setSongName(songCreateDto.getSongName());
        song.setDuration(songCreateDto.getDuration());
        return song;
    }

    public static Song mergeToEntity(SongCreateDto songCreateDto, Song song){
        song.setSongName(songCreateDto.getSongName());
        song.setDuration(songCreateDto.getDuration());
        return song;
    }


    public static User mapToEntity(UserCreateDto userCreateDto){
        User user = new User();
        user.setName(userCreateDto.getName());
        user.setPassword(userCreateDto.getPassword());
        user.setUserRole(UserRole.convertFrom(userCreateDto.getUserRole()));
        return user;
    }

    public static User mergeToEntity(UserCreateDto userCreateDto, User user){
        user.setName(userCreateDto.getName());
        user.setPassword(userCreateDto.getPassword());
        user.setUserRole(UserRole.convertFrom(userCreateDto.getUserRole()));
        return user;
    }
}
