package cz.fi.muni.pa165.mapper;


import cz.fi.muni.pa165.dto.album.AlbumDto;
import cz.fi.muni.pa165.dto.album.AlbumUpdateDto;
import cz.fi.muni.pa165.dto.song.SongUpdateDto;
import cz.fi.muni.pa165.dto.user.UserUpdateDto;
import cz.fi.muni.pa165.entity.Musician;
import cz.fi.muni.pa165.entity.Offer;
import cz.fi.muni.pa165.dto.activity.ActivityUpdateDto;
import cz.fi.muni.pa165.dto.band.BandUpdateDto;
import cz.fi.muni.pa165.dto.manager.ManagerUpdateDto;
import cz.fi.muni.pa165.dto.musician.MusicianUpdateDto;
import cz.fi.muni.pa165.dto.offer.OfferUpdateDto;
import cz.fi.muni.pa165.entity.*;

public class UpdateDtoMapper {

    public static Musician mapToEntity(MusicianUpdateDto musicianUpdateDto, Musician musician){
        Musician mergedMusician = CreateDtoMapper.mergeToEntity(musicianUpdateDto, musician);
        mergedMusician.setId(musicianUpdateDto.getId());
        return mergedMusician;
    }

    public static Offer mapToEntity(OfferUpdateDto offerUpdateDto, Offer offer){
        Offer mergedOffer = CreateDtoMapper.mergedToEntity(offerUpdateDto, offer);
        mergedOffer.setId(offerUpdateDto.getId());
        return mergedOffer;
    }
    
    public static Activity mapToEntity(ActivityUpdateDto activityUpdateDto, Activity activity){
        Activity mergedActivity = CreateDtoMapper.mergeToEntity(activityUpdateDto, activity);
        mergedActivity.setId(activityUpdateDto.getId());
        return mergedActivity;
    }
    
    public static Band mapToEntity(BandUpdateDto bandUpdateDto, Band band){
        Band mergedBand = CreateDtoMapper.mergeToEntity(bandUpdateDto, band);
        mergedBand.setId(bandUpdateDto.getId());
        return mergedBand;
    }

    public static Manager mapToEntity(ManagerUpdateDto managerUpdateDto, Manager manager){
        Manager mergedManager = CreateDtoMapper.mergeToEntity(managerUpdateDto, manager);
        mergedManager.setId(managerUpdateDto.getId());
        return mergedManager;
    }

    public static Song mapToEntity(SongUpdateDto songUpdateDto, Song song){
        Song mergedSong = CreateDtoMapper.mergeToEntity(songUpdateDto, song);
        mergedSong.setId(songUpdateDto.getId());
        return mergedSong;
    }

    public static Album mapToEntity(AlbumUpdateDto albumUpdateDto, Album album){
        Album mergedAlbum = CreateDtoMapper.mergeToEntity(albumUpdateDto, album);
        mergedAlbum.setId(albumUpdateDto.getId());
        return mergedAlbum;
    }

    public static User mapToEntity(UserUpdateDto userUpdateDto, User user){
        User mergedUser = CreateDtoMapper.mergeToEntity(userUpdateDto, user);
        mergedUser.setId(userUpdateDto.getId());
        return mergedUser;
    }

}
