package cz.fi.muni.pa165;

import cz.fi.muni.pa165.entity.Activity;
import java.util.List;

/**
 * @author Dávid Želník 469323
 */
public interface ActivityService {
    
    /**
     * Creates an activity entity.
     *
     * @param activity Activity entity to create
     * @throws IllegalArgumentException if provided activity entity is null
     */
    Activity create(Activity activity);

    /**
     * Finds activity entity with given Id
     *
     * @param id Id of searched activity entity
     * @return null if activity entity is not found, activity entity otherwise
     * @throws IllegalArgumentException if provided ID is null
     */
    Activity findById(String id);

    /**
     * Finds list of activity entities for given name
     *
     * @param name Name of searched activity entity
     * @return Empty list if entities are not found, list of Activity entities otherwise
     */
    List<Activity> findByName(String name);

    /**
     * Updates a activity entity.
     *
     * @param activity Activity entity to update
     * @throws IllegalArgumentException if provided activity entity is null, or name is null, or type is null
     */
    Activity update(Activity activity);

    /**
     * Delete activity.
     *
     * @param activity Activity entity to be deleted
     * @throws IllegalArgumentException  if provided activity entity is null
     */
    Activity delete(Activity activity);

    /**
     * Finds all activity entity instances.
     *
     * @return all activity entities
     */
    List<Activity> findAll();
}
