package cz.fi.muni.pa165;

import cz.fi.muni.pa165.entity.Album;

import java.util.List;

/**
 * @author David Sapak
 */
public interface AlbumService {
    /**
     * Creates a album.
     * @param album album to be created
     * @return album that was created
     */
    Album create(Album album);

    /**
     * Finds album by Id.
     * @param Id Unique string that represents album Id
     */
    Album findById(String Id);

    /**
     * Finds albums by name
     * @param name name of album
     * @return albums with specific name
     */
    List<Album> findByName(String name) ;

    /**
     * Updates specific album
     * @param album Album to be updated
     * @return Updated album
     * @If of the values in album was null
     */
    Album update(Album album) ;

    /**
     * Deletes album from database
     * @param album Album to be deleted
     * @return Album that was deleted
     * @If one of the parameter values was null
     */
    Album delete(Album album) ;

    /**
     * finds all albums
     * @return all albums
     */
    List<Album> findAll();
}
