package cz.fi.muni.pa165;

import cz.fi.muni.pa165.entity.Band;
import java.util.List;

/**
 * @author Dávid Želník 469323
 */
public interface BandService {

    /**
     * Creates an band entity.
     *
     * @param band Band entity to create
     * @throws IllegalArgumentException if provided band entity is null
     */
    Band create(Band band);

    /**
     * Finds band entity with given Id
     *
     * @param id Id of searched band entity
     * @return null if band entity is not found, band entity otherwise
     * @throws IllegalArgumentException if provided ID is null
     */
    Band findById(String id);

    /**
     * Finds list of band entities for given name
     *
     * @param name Name of searched band entity
     * @return Empty list if entities are not found, list of Band entities otherwise
     */
    List<Band> findByName(String name);

    /**
     * Updates a band entity.
     *
     * @param band Band entity to update
     * @throws IllegalArgumentException if provided band entity is null, or name is null, or type is null
     */
    Band update(Band band);

    /**
     * Delete band.
     *
     * @param band Band entity to be deleted
     * @throws IllegalArgumentException  if provided band entity is null
     */
    Band delete(Band band);

    /**
     * Finds all band entity instances.
     *
     * @return all band entities
     */
    List<Band> findAll();
}
