package cz.fi.muni.pa165;

import cz.fi.muni.pa165.entity.Band;
import cz.fi.muni.pa165.entity.Manager;

import java.util.List;
import java.util.Set;


/**
 * @author Pavel Vašina - 445606
 */
public interface ManagerService {

    /**
     * Create new manager
     * @param manager entity to be created
     * @return created Manager
     */
    Manager create(Manager manager);

    /**
     * Find Manager by id
     * @param id Id of searched Manager
     * @return found Manager
     */
    Manager findById(String id);

    /**
     * Find Manager by name
     * @param name name of searched Manager
     * @return found Managers List
     */
    List<Manager> findByName(String name);

    /**
     * Update Manager
     * @param manager Manager to be updated
     * @return updated Manager
     */
    Manager update(Manager manager);

    /**
     * Delete Manager
     * @param manager Manager to be deleted
     * @return deleted Manager
     */
    Manager delete(Manager manager);

    /**
     * Add band to manager's managed bands list
     * @param manager manager to whom the band will be added
     * @return list of manager's managed bands
     */
    Set<Band> addManagedBand(Band band, Manager manager);

    /**
     * Finds all managers
     * @return list of all managers
     */
    List<Manager> findAll();
}
