package cz.fi.muni.pa165;

import cz.fi.muni.pa165.entity.Song;

import java.util.List;

/**
 * @author David Sapak
 */
public interface SongService {

    /**
     * Creates new song
     * @param song New song
     * @return Song that was created
     */
    Song create(Song song);

    /**
     * Finds song by Id
     * @param Id Unique identifier of song
     * @return Found song
     * @ If song was null
     */
    Song findById(String Id) ;

    /**
     * Finds all song with specific name
     * @param name Name of the specific song
     * @return List of songs that were found
     */
    List<Song> findByName(String name) ;

    /**
     * Updates specific song
     * @param song Song to be updated
     * @return Specific song
     */
    Song update(Song song) ;

    /**
     * Deletes song
     * @param song Song to be deleted
     * @return Deleted song
     */
    Song delete(Song song) ;

    /**
     * Finds all songs
     * @return List of all songs
     */
    List<Song> findAll();
}
