package cz.fi.muni.pa165;

import cz.fi.muni.pa165.dao.SongDao;
import cz.fi.muni.pa165.entity.Song;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author David Sapak
 */
@Service
public class SongServiceImpl implements SongService {
    private final SongDao songRepository;

    @Autowired
    public SongServiceImpl(SongDao songRepository){
        this.songRepository = songRepository;
    }

    @Override
    public Song create(Song song) {
        if(song == null){
            throw new IllegalArgumentException("Song cannot be null");
        }
        return songRepository.create(song);
    }

    @Override
    public Song findById(String Id)  {
        if(Id == null){
            throw new IllegalArgumentException("Id cannot be null");
        }
        return songRepository.findById(Id);
    }

    @Override
    public List<Song> findByName(String name)  {
        if(name == null){
            throw new IllegalArgumentException("Song name cannot be null");
        }
        return songRepository.findByName(name);
    }

    @Override
    public Song update(Song song)  {
        return songRepository.update(song);
    }

    @Override
    public Song delete(Song song)  {
        if(song == null){
            throw new IllegalArgumentException("Song cannot be null");
        }
        Song repo = songRepository.findById(song.getId());
        if(repo == null){
            throw new IllegalArgumentException("Song has to in database");
        }

        return songRepository.delete(song);
    }

    @Override
    public List<Song> findAll() {
        return songRepository.findAll();
    }
}
