import axios from 'axios'

const ACTIVITY_URL = 'http://localhost:8080/pa165/rest/activity'

class ActivityService {
    async getActivities() {
        return axios.get(ACTIVITY_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async send(method, url, body){
        await axios({
            headers: {
                Accept: "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: 'http://localhost:8080/pa165/rest/band' + url,
            data: JSON.stringify(body)
        });
    }

    async createActivity(name, time, band) {
        const body = {name : name, time  : time, bandId : band};
        await this.send('post', '/create', body)
    }
}

export default new ActivityService();
