import axios from 'axios'

const ALBUM_URL = 'http://localhost:8080/pa165/rest/album'

class AlbumService {
    async create(nameParam, bandIdParam, songsParam){
        const body = {name : nameParam, bandId  : bandIdParam, songs:{songsParam}}
        await this.send("post", "/create", body)
    }

    async getAlbums() {
        return axios.get(ALBUM_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }
    async send(method, url, body){
        await axios({
            headers: {
                Accept: "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: ALBUM_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new AlbumService();