import axios from 'axios'

const MUS_URL = 'http://localhost:8080/pa165/rest/musicians'

class MusiciansService {
    async createMusicains(nameParam, musicianTypeParama, bandIdParam){
        const body = {name : nameParam, musicianType  : musicianTypeParama, bandId : bandIdParam};
        await this.send('post', '/create', body)
    }

    async delete(id){
        await this.send('delete', '/delete/' + id, null)
    }

    async upadate(paramId, nameParam, musicianTypeParama, bandIdParam){
        const body = {id: paramId, name : nameParam, musicianType  : musicianTypeParama, bandId : bandIdParam}
        await this.send("put", "/update", body)
    }

    async getsMusicians() {
        return axios.get(MUS_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async send(method, url, body){
        await axios({
            headers: {
                Accept: "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: 'http://localhost:8080/pa165/rest/musicians' + url,
            data: JSON.stringify(body)
        });
    }


    async acceptOffer(musicianId, offerId){
        return axios.post(`${MUS_URL}/accept-offer/${offerId}`,
            {
                id: musicianId,
            },
            {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }
}

export default new MusiciansService();
