import axios from 'axios'

const OFFER_URL = 'http://localhost:8080/pa165/rest/offer'

class OfferService {
    async getOffers() {
        return axios.get(OFFER_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }

    async createOffer(nameParam, bandIdParam){
        console.log(nameParam, bandIdParam)
        const body = {name : nameParam, bandId : bandIdParam};
        await this.send('post', '/create', body)
    }
    async send(method, url, body){
        await axios({
            headers: {
                Accept: "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: OFFER_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new OfferService();
