import axios from 'axios'

const SONG_URL = 'http://localhost:8080/pa165/rest/song'

class SongService {
    async create(nameParam, durationPara, albumIdParam){
        const body = {songName : nameParam, duration: durationPara, albumId:albumIdParam}
        await this.send("post", "/create", body)
    }

    async getAlbums() {
        return axios.get(SONG_URL, {
            headers: {
                'Access-Control-Allow-Origin': '*',
                'Accept': 'application/json'
            }
        });
    }
    async send(method, url, body){
        await axios({
            headers: {
                Accept: "application/json",
                "Content-Type": "application/json",
              },
            method: method,
            url: SONG_URL + url,
            data: JSON.stringify(body)
        });
    }
}

export default new SongService();